#ifndef RAMPSSTEPPER_H_
#define RAMPSSTEPPER_H_


class RampsStepper {
public:
  RampsStepper(int aStepPin, int aDirPin, int aEnablePin, bool aInverse);
  void enable(bool value = true);
  void disable();
  
  bool isOnPosition() const;
  int getPosition() const;
  void setPosition(int value);
  void stepToPosition(int value);
  void stepRelative(int value);
  
  float getPositionRad() const;
  void setPositionRad(float rad);
  void stepToPositionRad(float rad);
  void stepRelativeRad(float rad);
  
  void update(int aDelay=40);
  
  void setReductionRatio(float gearRatio, int stepsPerRev);
private:
  long stepperStepTargetPosition;
  long stepperStepPosition;
    
  int stepPin;
  int dirPin;
  int enablePin; 
  bool inverse;  
  
  float radToStepFactor;
};

#endif
